unit uSpriteText;
// Exemple parfait de detournement de la classe TSprite !
interface
uses
  Windows,Graphics,uSprite;

type
  TSpriteText = class (TSprite)
  private
    fText : String;
    fColorBackground,fColorFont : TColor;
    procedure SetText(AText : String);
  public
    property Text : String read fText write SetText;
    constructor Create(AText : String;X,Y : integer ; AColorBackground : TColor);overload;
    constructor Create(AText : String;X,Y : integer ; AColorBackground,AColorFont : TColor);overload;
  end;

implementation
uses uGameDEF;

constructor TSpriteText.Create(AText : String;X,Y : integer;AColorBackground : TColor);
var
  BmpTemp : TBitmap;
begin
  fColorBackground := AColorBackground ;
  fColorfont := RGB(0,0,0);
  BmpTemp := TBitmap.Create;
  BmpTemp.Width := BmpTemp.Canvas.TextWidth(AText);
  BmpTemp.Height := BmpTemp.Canvas.TextHeight(AText);

  inherited Create(BmpTemp,BmpTemp.Width,BmpTemp.Height);
  BmpTemp.Free;
  SetText(AText);
  SetCoord(X,Y);
end;

constructor TSpriteText.Create(AText : String;X,Y : integer;AColorBackground,AColorfont : TColor);
var
  BmpTemp : TBitmap;
begin
  fColorBackground := AColorBackground;
  fColorfont := AColorfont;
  BmpTemp := TBitmap.Create;
  BmpTemp.Width := BmpTemp.Canvas.TextWidth(AText);
  BmpTemp.Height := BmpTemp.Canvas.TextHeight(AText);

  inherited Create(BmpTemp,BmpTemp.Width,BmpTemp.Height);
  BmpTemp.Free;

  SetText(AText);
  SetCoord(X,Y);
end;

procedure TSpriteText.SetText(AText : String);
begin
  fText := AText;
  Bitmap.Canvas.Font.Color :=fColorFont;
  Bitmap.Canvas.Brush.Color := fColorBackground;
  Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);
  Bitmap.Canvas.TextOut(0,0,fText);
end;

end.

